<app-loading *ngIf="isLoadingPage"></app-loading>
<div class='data-table' oncontextmenu='return false;'>
  <form [formGroup]='form'>
    <div class='form__group form_group--array form_group--identity' [formArrayName]='identities'>
      <nz-table
        [nzData]="['']"
        [nzShowPagination]='false'
        [nzNoResult]='null'
        nzBordered
      >
        <thead>
        <tr>
          <th scope='col' class='text-nowrap text-center'>{{'staffManager.table.documentType' | translate}}</th>
          <th scope='col' class='text-nowrap text-center'>{{'staffManager.table.identityNumber' | translate}}</th>
          <th scope='col' class='text-nowrap text-center'>{{'staffManager.table.dateOfIdentity' | translate}}</th>
          <th scope='col' class='text-nowrap text-center'>{{'staffManager.table.placeOfIdentity' | translate}}</th>
          <th scope='col' class='text-center' nzWidth='70px'>{{'staffManager.table.documentMain' | translate}}</th>
          <th scope='col' class='text-nowrap text-center'>{{'staffManager.table.identityExpireDate' | translate}}</th>
          <th scope='col' class='text-nowrap text-center'>{{'common.button.delete' | translate}}</th>
        </tr>
        </thead>
        <tbody>
        <tr class='tr-for-class' *ngFor="let identity of form.get(identities)['controls']; let i = index"
            [formGroupName]='i'>
          <td class='text-nowrap'>
            <mb-select [mbDataSelects]='listIdentityType'
                       (mbEventEmit)="selectIdentityType($event, i)"
                       [mbOptionHeightPx]='56' [mbOptionOverflowSize]='5'
                       [mbType]="isSubmitted && identity.controls[identityType].errors ? 'error' : 'default'"
                       [mbShowError]='isSubmitted && identity.controls[identityType].errors !== null'
                       [mbErrors]='identity.controls[identityType].errors'
                       [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.table.documentType' | translate }}]"
                       mbPlaceholder="{{'staffManager.table.documentType' | translate}}"
                       [formControlName]='identityType'></mb-select>
          </td>
          <td class='text-nowrap'>
            <mb-input-text appNumberInput [formControlName]='identityNumber'
                           (ngModelChange)='checkDuplicate()'
                           [mbShowFlexEnd]='false' [mbMaxLength]='12' [mnMinLength]='6'
                           [mbType]="isSubmitted && identity.controls[identityNumber].errors ? 'error' : 'default'"
                           [mbShowError]='isSubmitted && identity.controls[identityNumber].errors !== null'
                           [mbErrors]='identity.controls[identityNumber].errors'
                           [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.table.identityNumber' | translate }},
                           { errorName: 'minlength', errorDescription: 'staffManager.validate.minLength' | translate: {'numberLength': 6}},
                           { errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': 12}},
                           { errorName: 'accDuplicate', errorDescription: 'staffManager.validate.duplicate' | translate: {'param': 'staffManager.table.identityNumber' | translate}}]"
                           mbPlaceholderText="{{'staffManager.table.identityNumber' | translate}}"></mb-input-text>
          </td>
          <td class='text-nowrap'>
            <!--<mb-mb-input-text [formControlName]="dateOfIdentity"
                           [mbShowFlexEnd]="false"
                           [mbType]="isSubmitted && identity.controls[dateOfIdentity].errors ? 'error' : 'default'"
                           [mbShowError]="isSubmitted && identity.controls[dateOfIdentity].errors !== null"
                           [mbErrors]="identity.controls[dateOfIdentity].errors"
                           [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffManager.validate.required' | translate: {'param': 'staffManager.table.dateOfIdentity' | translate }}]"
                           [mbIsDatepicker]="true"
                           mbPlaceholderText="&#45;&#45;{{'staffManager.table.dateOfIdentity' | translate}}&#45;&#45;"></mb-mb-input-text>-->
            <mb-date-picker
              [mbType]="isSubmitted && identity.errors ? 'error' : 'default'"
              [mbShowError]='isSubmitted && identity.errors !== null'
              [mbErrors]='identity.errors'
              [mbErrorDefs]="[{ errorName: 'rangeDateError', errorDescription: 'staffManager.validate.rangeDate.pareDate' | translate:
        {'fromDate': 'staffManager.table.dateOfIdentity' | translate, 'toDate': 'staffManager.table.identityExpireDate' | translate}}]"
              mbPlaceholderText="{{'staffManager.table.dateOfIdentity' | translate}}"
              [formControlName]='dateOfIdentity'></mb-date-picker>
          </td>
          <td class='text-nowrap'>
            <ng-container *ngIf="identity.controls[identityType].value === constant.PAPERS_CODE.ID_NO || identity.controls[identityType].value === constant.PAPERS_CODE.CITIZEN_ID; else other">
              <mb-select [mbDataSelects]='identity.controls[listIdPlace]?.value'
                         [mbType]="isSubmitted && identity.controls[placeOfIdentity].errors ? 'error' : 'default'"
                         [mbShowError]='isSubmitted && identity.controls[placeOfIdentity].errors !== null'
                         [mbErrors]='identity.controls[placeOfIdentity].errors'
                         [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': 199}}]"
                         mbPlaceholder="{{'staffManager.table.placeOfIdentity' | translate}}"
                         [formControlName]='placeOfIdentity'></mb-select>
            </ng-container>
            <ng-template #other>
              <mb-input-text [formControlName]='placeOfIdentity'
                             [mbShowFlexEnd]='false' [mbMaxLength]='199'
                             [mbType]="isSubmitted && identity.controls[placeOfIdentity].errors ? 'error' : 'default'"
                             [mbShowError]='isSubmitted && identity.controls[placeOfIdentity].errors !== null'
                             [mbErrors]='identity.controls[placeOfIdentity].errors'
                             [mbErrorDefs]="[{ errorName: 'maxlength', errorDescription: 'staffManager.validate.maxLength' | translate: {'numberLength': 199}}]"
                             mbPlaceholderText="{{'staffManager.table.placeOfIdentity' | translate}}"></mb-input-text>
            </ng-template>
            </td>
          <td class='text-center'>
            <nz-radio-group formControlName='index' [(ngModel)]='radioValue'>
              <label nz-radio [nzValue]='i'></label>
            </nz-radio-group>
          </td>
          <td class='text-nowrap'>
            <mb-date-picker
              [mbType]="isSubmitted && identity.errors ? 'error' : 'default'"
              [mbShowError]='isSubmitted && identity.errors !== null'
              [mbErrors]='identity.errors'
              mbPlaceholderText="{{'staffManager.table.identityExpireDate' | translate}}"
              [formControlName]='identityExpireDate' [mbErrorDefs]="[{ errorName: 'rangeDateError', errorDescription: 'staffManager.validate.rangeDate.pareDateMore' | translate:
        {'toDate': 'staffManager.table.identityExpireDate' | translate, 'fromDate': 'staffManager.table.dateOfIdentity' | translate}}]">
            </mb-date-picker>
            <!--<mb-mb-input-text [formControlName]="identityExpireDate"
                           [mbIsDatepicker]="true"
                           [mbShowFlexEnd]="false"
                           mbPlaceholderText="&#45;&#45;{{'staffManager.table.identityExpireDate' | translate}}&#45;&#45;"></mb-mb-input-text>-->
          </td>
          <td class='text-center'>
            <mb-button mbButtonType='ONLY_ICON' mbButtonIconType='AWESOME' nz-popconfirm
                       nzPopconfirmTitle="{{'staffManager.table.action.confirmDelete' | translate}}"
                       nzCancelText="{{'staffManager.table.action.cancel' | translate}}"
                       nzOkType='primary'
                       nzOkText="{{'staffManager.table.action.yes' | translate}}"
                       (nzOnConfirm)='deleteItem(identity.value, i)'
                       nzPopconfirmPlacement='top' mbPrefixIcon='fal fa-trash-alt'></mb-button>
          </td>
        </tr>
        </tbody>
      </nz-table>
    </div>
  </form>
  <div class='form__group--action form__group--identity--action'
       style='display: flex; justify-content: right; margin-top: 30px'>
    <mb-button mbButtonType='NO_BORDER' mbButtonSize='VERY_LARGE' mbButtonTextColor='#141ED2'
               mbButtonText="{{'staffManager.button.addition' | translate}}"
               (click)='addFormArray()'
               mbPrefixIcon='plus'></mb-button>
  </div>
</div>
